## ros-indigo-cob-twist-controller 0.6.17

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(cob_twist_controller)

find_package(catkin REQUIRED COMPONENTS cmake_modules cob_control_msgs cob_srvs dynamic_reconfigure eigen_conversions geometry_msgs kdl_conversions kdl_parser nav_msgs pluginlib roscpp roslint sensor_msgs std_msgs tf tf_conversions trajectory_msgs urdf visualization_msgs)

find_package(Boost REQUIRED COMPONENTS thread)

find_package(Eigen REQUIRED)
add_definitions(${EIGEN_DEFINITIONS})

find_package(orocos_kdl REQUIRED)

catkin_python_setup()

generate_dynamic_reconfigure_options(
  cfg/TwistController.cfg
)

catkin_package(
  CATKIN_DEPENDS cob_control_msgs cob_srvs dynamic_reconfigure eigen_conversions geometry_msgs kdl_conversions kdl_parser nav_msgs pluginlib roscpp sensor_msgs std_msgs tf tf_conversions urdf visualization_msgs
  DEPENDS Boost
  INCLUDE_DIRS include
  LIBRARIES damping_methods inv_calculations constraint_solvers limiters controller_interfaces kinematic_extensions inverse_differential_kinematics_solver twist_controller
)

### BUILD ###
include_directories(include ${catkin_INCLUDE_DIRS} ${EIGEN_INCLUDE_DIRS} ${orocos_kdl_INCLUDE_DIRS})

set(SRC_C_DIR "src/constraint_solvers")
set(SRC_CS_DIR "${SRC_C_DIR}/solvers")

## plugin library
add_library(controller_interfaces src/controller_interfaces/controller_interface.cpp)
add_dependencies(controller_interfaces ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(controller_interfaces ${catkin_LIBRARIES})

## internal libraries
add_library(damping_methods src/damping_methods/damping.cpp)
add_dependencies(damping_methods ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(damping_methods ${catkin_LIBRARIES})

add_library(inv_calculations src/inverse_jacobian_calculations/inverse_jacobian_calculation.cpp)
add_dependencies(inv_calculations ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(inv_calculations ${catkin_LIBRARIES})

add_library(constraint_solvers ${SRC_CS_DIR}/unconstraint_solver.cpp ${SRC_CS_DIR}/wln_joint_limit_avoidance_solver.cpp ${SRC_CS_DIR}/weighted_least_norm_solver.cpp ${SRC_CS_DIR}/gradient_projection_method_solver.cpp ${SRC_CS_DIR}/stack_of_tasks_solver.cpp ${SRC_CS_DIR}/task_priority_solver.cpp ${SRC_CS_DIR}/unified_joint_limit_singularity_solver.cpp ${SRC_C_DIR}/constraint_solver_factory.cpp)
add_dependencies(constraint_solvers ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(constraint_solvers damping_methods inv_calculations)

add_library(limiters src/limiters/limiter.cpp)
add_dependencies(limiters ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(limiters ${catkin_LIBRARIES} ${orocos_kdl_LIBRARIES})

add_library(kinematic_extensions src/kinematic_extensions/kinematic_extension_builder.cpp src/kinematic_extensions/kinematic_extension_dof.cpp src/kinematic_extensions/kinematic_extension_urdf.cpp src/kinematic_extensions/kinematic_extension_lookat.cpp)
add_dependencies(kinematic_extensions ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(kinematic_extensions ${catkin_LIBRARIES} ${orocos_kdl_LIBRARIES})

add_library(inverse_differential_kinematics_solver src/inverse_differential_kinematics_solver.cpp src/callback_data_mediator.cpp)
add_dependencies(inverse_differential_kinematics_solver ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(inverse_differential_kinematics_solver constraint_solvers kinematic_extensions ${orocos_kdl_LIBRARIES})

add_library(twist_controller src/cob_twist_controller.cpp)
add_dependencies(twist_controller ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(twist_controller inverse_differential_kinematics_solver limiters ${catkin_LIBRARIES} ${orocos_kdl_LIBRARIES})

add_executable(cob_twist_controller_node src/cob_twist_controller_node.cpp)
add_dependencies(cob_twist_controller_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cob_twist_controller_node twist_controller ${catkin_LIBRARIES} ${orocos_kdl_LIBRARIES})


### DEBUG NODES ###
add_executable(debug_trajectory_marker_node src/debug/debug_trajectory_marker_node.cpp)
add_dependencies(debug_trajectory_marker_node ${catkin_EXPORTED_TARGETS})
target_link_libraries(debug_trajectory_marker_node ${catkin_LIBRARIES})

add_executable(debug_evaluate_jointstates_node src/debug/debug_evaluate_jointstates_node.cpp)
add_dependencies(debug_evaluate_jointstates_node ${catkin_EXPORTED_TARGETS})
target_link_libraries(debug_evaluate_jointstates_node ${catkin_LIBRARIES} ${orocos_kdl_LIBRARIES})

add_executable(test_moving_average_node src/debug/test_moving_average_node.cpp)
add_dependencies(test_moving_average_node ${catkin_EXPORTED_TARGETS})
target_link_libraries(test_moving_average_node ${catkin_LIBRARIES})

add_executable(test_simpson_integrator_node src/debug/test_simpson_integrator_node.cpp)
add_dependencies(test_simpson_integrator_node ${catkin_EXPORTED_TARGETS})
target_link_libraries(test_simpson_integrator_node ${catkin_LIBRARIES})

add_executable(test_trajectory_command_sine_node src/debug/test_trajectory_command_sine_node.cpp)
add_dependencies(test_trajectory_command_sine_node ${catkin_EXPORTED_TARGETS})
target_link_libraries(test_trajectory_command_sine_node ${catkin_LIBRARIES})

add_executable(test_forward_command_sine_node src/debug/test_forward_command_sine_node.cpp)
add_dependencies(test_forward_command_sine_node ${catkin_EXPORTED_TARGETS})
target_link_libraries(test_forward_command_sine_node ${catkin_LIBRARIES})

add_executable(test_twist_command_sine_node src/debug/test_twist_command_sine_node.cpp)
add_dependencies(test_twist_command_sine_node ${catkin_EXPORTED_TARGETS})
target_link_libraries(test_twist_command_sine_node ${catkin_LIBRARIES})

roslint_cpp()

### INSTALL ###
install(TARGETS cob_twist_controller_node damping_methods inv_calculations constraint_solvers limiters controller_interfaces kinematic_extensions inverse_differential_kinematics_solver twist_controller
 ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
 LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
 RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS debug_trajectory_marker_node debug_evaluate_jointstates_node test_moving_average_node test_simpson_integrator_node test_trajectory_command_sine_node test_twist_command_sine_node
 ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
 LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
 RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/cob_twist_controller/
 DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(PROGRAMS scripts/test_publisher_twist.py scripts/test_publisher_twist_stamped.py scripts/test_publisher_twist_series.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}/scripts
)

install(FILES controller_interface_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-indigo-cob-twist-controller (0.6.17-0trusty) trusty; urgency=high

  * update maintainer
  * Contributors: fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Fri, 20 Jul 2018 22:00:00 -0000

ros-indigo-cob-twist-controller (0.6.16-0trusty) trusty; urgency=high

  * Merge remote-tracking branch 'origin/indigo_release_candidate' into indigo_dev
  * Merge pull request #159 <https://github.com/ipa320/cob_control/issues/159> from ipa-fxm/APACHE_license
    use license apache 2.0
  * use license apache 2.0
  * Contributors: Felix Messmer, ipa-fxm, ipa-uhr-mk

 -- Felix Messmer <fxm@ipa.fhg.de>  Sat, 06 Jan 2018 23:00:00 -0000

ros-indigo-cob-twist-controller (0.6.15-0trusty) trusty; urgency=high

  * handle continuous joints in ControllerInterfaceJointStates
  * handle continuous joints in position_limiter
  * harmonize createTask
  * remove unused TaskDamping
  * remove ConstraintParamFactory
  * harmonize ConstraintParams
  * set default values for damping methods
  * own param struct for unified solver
  * New singularity and joint limit avoidance method (#149 <https://github.com/ipa320/cob_control/issues/149>)
    * first implementation of new jla solver using sigmoid functions
    * first version of new JLA method working
    * last fix to new JLA solver
    * correction in parameter used in sigmoid damping method
    * new solver added and new jla method added to be tested and selected according to performance comparison
    * fix to rqt_reconfigure parameters
    * final correction to new solver and new weighting method
    * prints removed
    * square trajectory added
    * wln with sigmoid solver corrected
    * final corrections
    * final corrections to the solver formula
    * created unified singularity and joint limit avoidance class... other classes moved
    * restoring wln previous version of the solver
    * saturation block added in unified solver just for testing
    * saturation block corrected
    * checking new solver and constraints
    * corrected new test script for the new method
    * removed test files and corrected identation
    * defining GPM solver as default
    * fix identation
    * comment corrected
    * identation fix in contraint solver factory
    * finalize PR
  * cleanup leftovers
  * pluginlib approach for controller interfaces
  * add toggle for enforce_input_limits, implement both All and Individual Cartesian limiting
  * combine LimiterXContainer
  * limiter fixed
  * Limiter Base class removed
  * pull request changes
  * final implementation of cartesian limiter
  * bug fixed in class limiter container
  * bug fixed in class limiter container
  * cartesian limits introduced
  * remove sympy implementation and dependency
  * use xacro --inorder
  * final roslint
  * applied changes request in the pull request review
  * damping factor for old method replaced by a diagonal matrix
  * last corretions to pull request
  * corrections added according to last Felix comments
  * fixed changes done by rebase
  * prints removed for new damping function calculations
  * new method based of sigmoid function to singularity avoidance implemented
  * bug fix in least square calculation when changing to return matrix
  * starting to roslint some packages
  * manually fix changelog
  * Contributors: Bruno Brito, ipa-fxm

 -- Felix Messmer <fxm@ipa.fhg.de>  Mon, 17 Jul 2017 22:00:00 -0000

ros-indigo-cob-twist-controller (0.6.14-0trusty) trusty; urgency=high



 -- Felix Messmer <fxm@ipa.fhg.de>  Sun, 09 Oct 2016 22:00:00 -0000

ros-indigo-cob-twist-controller (0.6.13-0trusty) trusty; urgency=high



 -- Felix Messmer <fxm@ipa.fhg.de>  Sun, 09 Oct 2016 22:00:00 -0000

ros-indigo-cob-twist-controller (0.6.12-0trusty) trusty; urgency=high

  * cob_twist_controller: fix add_dependencies calls
  * Contributors: ipa-mig

 -- Felix Messmer <fxm@ipa.fhg.de>  Sun, 09 Oct 2016 22:00:00 -0000

ros-indigo-cob-twist-controller (0.6.11-0trusty) trusty; urgency=high

  * reduce output
  * outsource obstacle_distance messages
  * remove support for interpol_position controller
  * debug output
  * use joint_group_velocity_controller for torso extension
  * verify position limit scaling factor
  * fix typo
  * fix lookat: do not look backwards
  * missing sympy dependency
  * add test publisher twist sine
  * avoid unecessary service calls to obstacle_distance
  * fix collision avoidance dimension segfault
  * infinitesiamal threshold for BaseActive
  * wider limits
  * enforce position limit
  * add test_forward_command_sine_node
  * cleanup period
  * Update test_trajectory_command_sine_node.cpp
  * adjust lookat extension limits
  * more compact parameter structure
  * make lookat linear axis configurable - axis and offset
  * cleanup roslint
  * add trajectory_command test node
  * introduce cfg-parameter integrator_smoothing
  * add debug publisher to simpson_integration
  * rename member variables
  * add q_dot_ik smoothing, adjust parameters
  * add timing members for period
  * Merge pull request #79 <https://github.com/ipa320/cob_control/issues/79> from ipa-fxm/fix_visualize_twist_marker
    visualize twist marker
  * proper reset for ControllerInterfaceJointStates
  * visualize angular twist
  * fix visualize twist marker
  * Fixed the TwistDirection Marker
  * use undamped jacobian in nullspace projection
  * minor renaming
  * roslint cob_twist_controller
  * final roslint
  * add TimeStamp to trajectory_interface
  * also print limiting joint
  * prepare remapping for twist_mux in cartesian controller
  * add test nodes for SimpsonIntegrator
  * reset moving average
  * simplify API
  * use new API in SimpsonIntegrator
  * test new MovingAverage API
  * all new MovingAverage API
  * saver initialization of weighting
  * test scripts for moving_average
  * use interpolated position controller
  * add more debug scripts
  * consider various roslint/styleguide hints
  * apply change in parameter name
  * fix frame_id in visualizeTwist


=== debian/control ===
Source: ros-indigo-cob-twist-controller
Section: misc
Priority: extra
Maintainer: Felix Messmer <felixmessmer@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libeigen3-dev, ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-cob-control-msgs, ros-indigo-cob-srvs, ros-indigo-dynamic-reconfigure, ros-indigo-eigen-conversions, ros-indigo-geometry-msgs, ros-indigo-kdl-conversions, ros-indigo-kdl-parser, ros-indigo-nav-msgs, ros-indigo-orocos-kdl, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-roslint, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-trajectory-msgs, ros-indigo-urdf, ros-indigo-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-cob-twist-controller
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, ros-indigo-cmake-modules, ros-indigo-cob-control-msgs, ros-indigo-cob-frame-tracker, ros-indigo-cob-srvs, ros-indigo-dynamic-reconfigure, ros-indigo-eigen-conversions, ros-indigo-geometry-msgs, ros-indigo-kdl-conversions, ros-indigo-kdl-parser, ros-indigo-nav-msgs, ros-indigo-orocos-kdl, ros-indigo-pluginlib, ros-indigo-robot-state-publisher, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-rviz, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-topic-tools, ros-indigo-trajectory-msgs, ros-indigo-urdf, ros-indigo-visualization-msgs, ros-indigo-xacro
Description: The main purpose of the cob_twist_controller is to convert target twists into joint velocities.
 Therefore it makes use of several implemented inverse kinematics approaches at the first order differential level. The inverse differential kinematics solver considers kinematic chain extensions, singularity robustness, redundancy resolution and priority-based methods. To avoid hardware destruction there is a limiter interface active as well. Via parameter server users can dynamically configure the solving strategy.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-cob-twist-controller//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
